searchNodes=[{"doc":"Journey helps you define and execute workflow-like processes, simply, scalably, and reliably.Examples of applications that could be powered by processes defined and executed with Journey:a food delivery application,a web site for computing horoscopes,a web site for accepting and processing credit card applications.Journey process executions are designed to be persistent and resilient, to survivce service restarts, and to, quite literally, scale with your service.Project StatusHere is the project's current state and mini-roadmap:[x] Initial version, the state of executions lives in memory, does not survive service restarts.[ ] The state of executions is persisted, executions survive service restarts.[ ] Executions run in multiple replicas of your service.[ ] Maybe: loops in steps.[ ] Maybe: support for specific persistence types.[ ] Maybe: support for specific persistence types.[ ] Maybe: timer-based cron-like executions.[ ] Maybe: better naming / metaphores for Journey's / Processes / Executions[ ] Maybe: Documentation includes an example application.[ ] Maybe: Documentation includes examples of versioned processes.[ ] Maybe: Retry policy is configurable, clearly documented.[ ] Maybe: Logging is configurable, clearly documented.[ ] Maybe: Monitoring is clearly documented.[ ] Maybe: Performance and scalability are clearly documented.[ ] Maybe: More concise and expressive ways to define journies.The project is in active development.For questions, comments, bug reports, feature requests please create issues (and/or Pull Requests:).InstallationThe package can be installed from Hex by adding journey to your list of dependencies in mix.exs:def deps do [ {:journey, &quot;~&gt; 0.0.3&quot;} ] endExample: a Web Site for Computing Horoscopes(If you prefer to play with the Livebook version of this example, please see ./examples directory of the github repo.)Imagine a web site that computes horoscopes.To power this web site we will define a Journey.Process, consisting of a collection of Journey.Steps.Some of the steps (:user_name, :birth_day, :birth_month) get their values from the user, while others (:astrological_sign, :horoscope) compute their values based on the data captured or computed so far, using functions that are part of those steps' definitions.This code fragment, defines the process, and then executes it, step by step, from the user (Mario) entering their name and birthday, to the process coming back with Mario's horoscope.iex&gt; process = %Journey.Process{ ...&gt; process_id: &quot;horoscopes-r-us&quot;, ...&gt; steps: [ ...&gt; %Journey.Step{name: :first_name}, ...&gt; %Journey.Step{name: :birth_month}, ...&gt; %Journey.Step{name: :birth_day}, ...&gt; %Journey.Step{ ...&gt; name: :astrological_sign, ...&gt; func: fn _values -&gt; ...&gt; # Everyone is a Taurus! ...&gt; {:ok, &quot;taurus&quot;} ...&gt; end, ...&gt; blocked_by: [ ...&gt; %Journey.BlockedBy{step_name: :birth_month, condition: :provided}, ...&gt; %Journey.BlockedBy{step_name: :birth_day, condition: :provided} ...&gt; ] ...&gt; }, ...&gt; %Journey.Step{ ...&gt; name: :horoscope, ...&gt; func: fn values -&gt; ...&gt; name = values[:first_name].value ...&gt; sign = values[:astrological_sign].value ...&gt; { ...&gt; :ok, ...&gt; &quot;\#{name}! You are a righteous \#{sign}! This is the perfect week to smash the racist patriarchy!&quot; ...&gt; } ...&gt; end, ...&gt; blocked_by: [ ...&gt; %Journey.BlockedBy{step_name: :first_name, condition: :provided}, ...&gt; %Journey.BlockedBy{step_name: :astrological_sign, condition: :provided} ...&gt; ] ...&gt; } ...&gt; ] ...&gt;} iex&gt; iex&gt; # Start an execution of the process. iex&gt; # (this could be called by the app&#39;s phoenix controller, when a user starts the process on the web site). iex&gt; execution = Journey.Process.execute(process) iex&gt; iex&gt; # The user entered their name. Update the execution. iex&gt; # (this could be called by the app&#39;s Phoenix controller, when a user submits their name). iex&gt; {:ok, execution} = Journey.Execution.update_value(execution, :first_name, &quot;Mario&quot;) iex&gt; iex&gt; # Mario entered their birth month and day. Update the execution. iex&gt; # (this could be called by the app&#39;s Phoenix controller, when a user submits these values). iex&gt; {:ok, execution} = Journey.Execution.update_value(execution, :birth_month, 3) iex&gt; {:ok, execution} = Journey.Execution.update_value(execution, :birth_day, 10) iex&gt; iex&gt; # :astrological_sign is no longer blocked, and it is now &quot;:computing&quot;. iex&gt; {:computing, _} = Journey.Execution.read_value(execution, :astrological_sign) iex&gt; iex&gt; # Get a human friendly textual summary of the current status of this execution, in case we want to take a look. iex&gt; execution.execution_id |&gt; Journey.Execution.load!() |&gt; Journey.Execution.get_summary() |&gt; IO.puts() iex&gt; iex&gt; # Get all values in this execution, in case the code wants to take a look. iex&gt; values = Journey.Execution.get_all_values(execution) iex&gt; values[:first_name][:status] :computed iex&gt; values[:first_name][:value] &quot;Mario&quot; iex&gt; iex&gt; # In just a few moments, we will have Mario&#39;s astrological sign. iex&gt; :timer.sleep(100) iex&gt; {:computed, &quot;taurus&quot;} = execution.execution_id |&gt; Journey.Execution.load!() |&gt; Journey.Execution.read_value(:astrological_sign) iex&gt; iex&gt; # :horoscope computation is no longer blocked. In just a few milliseconds, we will have Mario&#39;s horoscope. iex&gt; # The web page or the app&#39;s Phoenix controller can poll for this value, and render it when it becomes :computed. iex&gt; :timer.sleep(100) iex&gt; {:computed, horoscope} = execution.execution_id |&gt; Journey.Execution.load!() |&gt; Journey.Execution.read_value(:horoscope) iex&gt; horoscope &quot;Mario! You are a righteous taurus! This is the perfect week to smash the racist patriarchy!&quot;Journey.Execution execution will save every value it receives or computes, so, even if the server restarts (TODO: link to the issue), the execution will continue where it left off (unless you are using one-node-in-memory configuration). And, because Journey.Process runs as part of your application, it, quite literally, scales with your application.In our example, functions are very simple, but if your function is, for some reason, temporarily unable to compute the value, it can return {:retriable, error_information}, and Journey will retry it, according to the step's (implicit, in our example) retry policy. (TODO: link to the issue for implementing this).IntrospectionAt any point in the lifetime of an execution, you can get a human-friendly summary of its state:execution.execution_id |&gt; Journey.Execution.load!() |&gt; Journey.Execution.get_summary |&gt; IO.putsExecution Summary Execution ID: hs5ijpaif7 Execution started: 2021-03-13 07:59:08Z Revision: 2 All Steps: [started_at]: '1615622348'. Blocked by: []. Self-computing: false [first_name]: 'not_computed'. Blocked by: []. Self-computing: false [birth_month]: 'not_computed'. Blocked by: []. Self-computing: false [birth_day]: '29'. Blocked by: []. Self-computing: false [astrological_sign]: 'not_computed'. Blocked by: [birth_month]. Self-computing: true [horoscope]: 'not_computed'. Blocked by: [first_name, astrological_sign]. Self-computing: true :okSource CodeThe source code for this package can be found on Github: https://github.com/shipworthy/journey.DocumentationFull documentation can be found at https://hexdocs.pm/journey/.Also, please see a Livebook in ./examples directory of the github repo for an example.","ref":"Journey.html","title":"Journey","type":"module"},{"doc":"","ref":"Journey.BlockedBy.html","title":"Journey.BlockedBy","type":"module"},{"doc":"An execution of a process.An execution gets created when you callexecution = Journey.Process.execute(process)The execution can then be updated with new values{:ok, updated_execution} = Journey.Execution.update_value( execution.execution_id, :first_name, &quot;Luigi&quot;)and its can be introspected.&gt; updated_execution |&gt; Journey.Execution.read_value(:first_name) {:computed, &quot;Luigi&quot;}","ref":"Journey.Execution.html","title":"Journey.Execution","type":"module"},{"doc":"Get all steps in the execution, and their current state.iex&gt; execution_id |&gt; Journey.Execution.get_all_values [ started_at: [ status: :computed, value: 1615790505, self_computing: false, blocked_by: [] ], first_name: [ status: :not_computed, value: nil, self_computing: false, blocked_by: [] ], birth_month: [ status: :not_computed, value: nil, self_computing: false, blocked_by: [] ], birth_day: [ status: :not_computed, value: nil, self_computing: false, blocked_by: [] ], astrological_sign: [ status: :not_computed, value: nil, self_computing: true, blocked_by: [:birth_month, :birth_day] ], horoscope: [ status: :not_computed, value: nil, self_computing: true, blocked_by: [:first_name, :astrological_sign] ] ]","ref":"Journey.Execution.html#get_all_values/1","title":"Journey.Execution.get_all_values/1","type":"function"},{"doc":"Get all the steps in the execution that are blocked by other steps.&gt; execution |&gt; Journey.Execution.get_blocked_steps() [ astrological_sign: %Journey.Value{ name: :astrological_sign, status: :not_computed, update_time: 0, value: nil }, horoscope: %Journey.Value{ name: :horoscope, status: :not_computed, update_time: 0, value: nil } ]","ref":"Journey.Execution.html#get_blocked_steps/1","title":"Journey.Execution.get_blocked_steps/1","type":"function"},{"doc":"Returns a human friendly string containing the summary of the current status of the execution.&gt; execution |&gt; Journey.Execution.get_summary |&gt; IO.puts Execution Summary Execution ID: keo56rvimq Execution started: 2021-03-15 06:41:45Z Revision: 1 All Steps: [started_at]: &#39;1615790505&#39;. Blocked by: []. Self-computing: false [first_name]: &#39;not_computed&#39;. Blocked by: []. Self-computing: false [birth_month]: &#39;not_computed&#39;. Blocked by: []. Self-computing: false [birth_day]: &#39;not_computed&#39;. Blocked by: []. Self-computing: false [astrological_sign]: &#39;not_computed&#39;. Blocked by: [birth_month, birth_day]. Self-computing: true [horoscope]: &#39;not_computed&#39;. Blocked by: [first_name, astrological_sign]. Self-computing: true :ok","ref":"Journey.Execution.html#get_summary/1","title":"Journey.Execution.get_summary/1","type":"function"},{"doc":"Get all the steps in an execution that have yet to receive a value.&gt; Journey.Execution.get_unfilled_steps(execution) [ astrological_sign: %Journey.Value{ name: :astrological_sign, status: :not_computed, update_time: 0, value: nil }, birth_day: %Journey.Value{ name: :birth_day, status: :not_computed, update_time: 0, value: nil }, birth_month: %Journey.Value{ name: :birth_month, status: :not_computed, update_time: 0, value: nil }, first_name: %Journey.Value{ name: :first_name, status: :not_computed, update_time: 0, value: nil }, horoscope: %Journey.Value{ name: :horoscope, status: :not_computed, update_time: 0, value: nil } ]","ref":"Journey.Execution.html#get_unfilled_steps/1","title":"Journey.Execution.get_unfilled_steps/1","type":"function"},{"doc":"Fetches the value contained in a specificified step.iex(1)&gt; Journey.Execution.get_value(execution_id, :birth_day) 26","ref":"Journey.Execution.html#get_value/2","title":"Journey.Execution.get_value/2","type":"function"},{"doc":"Load an execution from store, given its execution id.{:ok, execution} = Journey.Execution.load(execution_id)","ref":"Journey.Execution.html#load/1","title":"Journey.Execution.load/1","type":"function"},{"doc":"Load an execution from store, given its execution id.execution = Journey.Execution.load!(execution_id)","ref":"Journey.Execution.html#load!/1","title":"Journey.Execution.load!/1","type":"function"},{"doc":"Read value from an execution.&gt; execution |&gt; Journey.Execution.read_value(:first_name) {:computed, &quot;Mario&quot;}&gt; execution |&gt; Journey.Execution.read_value(:astrological_sign) {:computing, nil}&gt; execution |&gt; Journey.Execution.read_value(:horoscope_name) {:not_computed, nil}&gt; execution |&gt; Journey.Execution.read_value(:ssn) {:error, :unknown_step}","ref":"Journey.Execution.html#read_value/2","title":"Journey.Execution.read_value/2","type":"function"},{"doc":"Update a value in an execution, given the execution or execution id. The new value gets immediately persisted. Any steps that become unblocked by this value will start computing.The function returns a tuple that, in case of success, includes the updated execution.{:ok, updated_execution} = Journey.Execution.update_value(execution_id, :first_name, &quot;Luigi&quot;) {:unknown_step, _} = Journey.Execution.update_value(execution_id, :ssn, &quot;111-11-1111&quot;) {:unknown_execution_id, _} = Journey.Execution.update_value(no_such_execution, :first_name, &quot;Luigi&quot;)","ref":"Journey.Execution.html#update_value/3","title":"Journey.Execution.update_value/3","type":"function"},{"doc":"","ref":"Journey.Execution.html#update_value!/3","title":"Journey.Execution.update_value!/3","type":"function"},{"doc":"","ref":"Journey.Execution.html#wait_for_result/4","title":"Journey.Execution.wait_for_result/4","type":"function"},{"doc":"Stores the information related to an execution of a process.execution_idThe id of this execution.processThe process that this execution is running.valuesThe values associated with this execution, in various states of computation.save_versionThe version of this execution. Every time an execution gets updated, it is persisted, and its save_version value gets incremented.","ref":"Journey.Execution.html#t:t/0","title":"Journey.Execution.t/0","type":"type"},{"doc":"","ref":"Journey.ExecutionDbRecord.html","title":"Journey.ExecutionDbRecord","type":"module"},{"doc":"","ref":"Journey.ExecutionDbRecord.html#convert_to_execution_struct!/1","title":"Journey.ExecutionDbRecord.convert_to_execution_struct!/1","type":"function"},{"doc":"","ref":"Journey.ExecutionState.html","title":"Journey.ExecutionState","type":"module"},{"doc":"","ref":"Journey.Process.html","title":"Journey.Process","type":"module"},{"doc":"Starts a new execution of the process.Exampleiex&gt; process = %Journey.Process{ ...&gt; process_id: &quot;horoscopes-r-us&quot;, ...&gt; steps: [ ...&gt; %Journey.Step{name: :first_name}, ...&gt; %Journey.Step{name: :birth_month}, ...&gt; %Journey.Step{name: :birth_day}, ...&gt; %Journey.Step{ ...&gt; name: :astrological_sign, ...&gt; func: fn _values -&gt; ...&gt; # Everyone is a Taurus! ...&gt; {:ok, &quot;taurus&quot;} ...&gt; end, ...&gt; blocked_by: [ ...&gt; %Journey.BlockedBy{step_name: :birth_month, condition: :provided}, ...&gt; %Journey.BlockedBy{step_name: :birth_day, condition: :provided} ...&gt; ] ...&gt; }, ...&gt; %Journey.Step{ ...&gt; name: :horoscope, ...&gt; func: fn values -&gt; ...&gt; name = values[:first_name].value ...&gt; sign = values[:astrological_sign].value ...&gt; { ...&gt; :ok, ...&gt; &quot;\#{name}! You are a \#{sign}! Now is the perfect time to smash the racist patriarchy!&quot; ...&gt; } ...&gt; end, ...&gt; blocked_by: [ ...&gt; %Journey.BlockedBy{step_name: :first_name, condition: :provided}, ...&gt; %Journey.BlockedBy{step_name: :astrological_sign, condition: :provided} ...&gt; ] ...&gt; } ...&gt; ] ...&gt; } iex&gt; iex&gt; # Start a new execution of the process. iex&gt; execution = Journey.Process.execute(process) iex&gt; iex&gt; iex&gt; {:ok, execution} = Journey.Execution.update_value(execution, :first_name, &quot;Luigi&quot;) iex&gt; {:not_computed, _} = Journey.Execution.read_value(execution, :astrological_sign) iex&gt; {:ok, execution} = Journey.Execution.update_value(execution, :birth_month, 4) iex&gt; {:ok, execution} = Journey.Execution.update_value(execution, :birth_day, 29) iex&gt; :timer.sleep(100) # Give :astrological_sign&#39;s function a bit of time to run. iex&gt; {:computed, &quot;taurus&quot;} = execution.execution_id |&gt; Journey.Execution.load!() |&gt; Journey.Execution.read_value(:astrological_sign) iex&gt; :timer.sleep(200) # Give :horoscope&#39;s function a bit of time to run. iex&gt; {:computed, horoscope} = execution.execution_id |&gt; Journey.Execution.load!() |&gt; Journey.Execution.read_value(:horoscope) iex&gt; horoscope &quot;Luigi! You are a taurus! Now is the perfect time to smash the racist patriarchy!&quot;","ref":"Journey.Process.html#execute/1","title":"Journey.Process.execute/1","type":"function"},{"doc":"Holds the definition of a process.","ref":"Journey.Process.html#t:t/0","title":"Journey.Process.t/0","type":"type"},{"doc":"","ref":"Journey.Repo.html","title":"Journey.Repo","type":"module"},{"doc":"Callback implementation for Ecto.Repo.aggregate/3.","ref":"Journey.Repo.html#aggregate/3","title":"Journey.Repo.aggregate/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.aggregate/4.","ref":"Journey.Repo.html#aggregate/4","title":"Journey.Repo.aggregate/4","type":"function"},{"doc":"Callback implementation for Ecto.Repo.all/2.","ref":"Journey.Repo.html#all/2","title":"Journey.Repo.all/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.checked_out?/0.","ref":"Journey.Repo.html#checked_out?/0","title":"Journey.Repo.checked_out?/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.checkout/2.","ref":"Journey.Repo.html#checkout/2","title":"Journey.Repo.checkout/2","type":"function"},{"doc":"","ref":"Journey.Repo.html#child_spec/1","title":"Journey.Repo.child_spec/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.config/0.","ref":"Journey.Repo.html#config/0","title":"Journey.Repo.config/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.default_options/1.","ref":"Journey.Repo.html#default_options/1","title":"Journey.Repo.default_options/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete/2.","ref":"Journey.Repo.html#delete/2","title":"Journey.Repo.delete/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete!/2.","ref":"Journey.Repo.html#delete!/2","title":"Journey.Repo.delete!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.delete_all/2.","ref":"Journey.Repo.html#delete_all/2","title":"Journey.Repo.delete_all/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.exists?/2.","ref":"Journey.Repo.html#exists?/2","title":"Journey.Repo.exists?/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes an EXPLAIN statement or similar depending on the adapter to obtain statistics for the given query.See Ecto.Adapters.SQL.explain/4 for more information.","ref":"Journey.Repo.html#explain/3","title":"Journey.Repo.explain/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get/3.","ref":"Journey.Repo.html#get/3","title":"Journey.Repo.get/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get!/3.","ref":"Journey.Repo.html#get!/3","title":"Journey.Repo.get!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by/3.","ref":"Journey.Repo.html#get_by/3","title":"Journey.Repo.get_by/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_by!/3.","ref":"Journey.Repo.html#get_by!/3","title":"Journey.Repo.get_by!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.get_dynamic_repo/0.","ref":"Journey.Repo.html#get_dynamic_repo/0","title":"Journey.Repo.get_dynamic_repo/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.in_transaction?/0.","ref":"Journey.Repo.html#in_transaction?/0","title":"Journey.Repo.in_transaction?/0","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert/2.","ref":"Journey.Repo.html#insert/2","title":"Journey.Repo.insert/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert!/2.","ref":"Journey.Repo.html#insert!/2","title":"Journey.Repo.insert!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_all/3.","ref":"Journey.Repo.html#insert_all/3","title":"Journey.Repo.insert_all/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update/2.","ref":"Journey.Repo.html#insert_or_update/2","title":"Journey.Repo.insert_or_update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.insert_or_update!/2.","ref":"Journey.Repo.html#insert_or_update!/2","title":"Journey.Repo.insert_or_update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.load/2.","ref":"Journey.Repo.html#load/2","title":"Journey.Repo.load/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one/2.","ref":"Journey.Repo.html#one/2","title":"Journey.Repo.one/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.one!/2.","ref":"Journey.Repo.html#one!/2","title":"Journey.Repo.one!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.preload/3.","ref":"Journey.Repo.html#preload/3","title":"Journey.Repo.preload/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.prepare_query/3.","ref":"Journey.Repo.html#prepare_query/3","title":"Journey.Repo.prepare_query/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.put_dynamic_repo/1.","ref":"Journey.Repo.html#put_dynamic_repo/1","title":"Journey.Repo.put_dynamic_repo/1","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query.See Ecto.Adapters.SQL.query/4 for more information.","ref":"Journey.Repo.html#query/3","title":"Journey.Repo.query/3","type":"function"},{"doc":"A convenience function for SQL-based repositories that executes the given query.See Ecto.Adapters.SQL.query!/4 for more information.","ref":"Journey.Repo.html#query!/3","title":"Journey.Repo.query!/3","type":"function"},{"doc":"Callback implementation for Ecto.Repo.reload/2.","ref":"Journey.Repo.html#reload/2","title":"Journey.Repo.reload/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.reload!/2.","ref":"Journey.Repo.html#reload!/2","title":"Journey.Repo.reload!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.rollback/1.","ref":"Journey.Repo.html#rollback/1","title":"Journey.Repo.rollback/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.start_link/1.","ref":"Journey.Repo.html#start_link/1","title":"Journey.Repo.start_link/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stop/1.","ref":"Journey.Repo.html#stop/1","title":"Journey.Repo.stop/1","type":"function"},{"doc":"Callback implementation for Ecto.Repo.stream/2.","ref":"Journey.Repo.html#stream/2","title":"Journey.Repo.stream/2","type":"function"},{"doc":"A convenience function for SQL-based repositories that translates the given query to SQL.See Ecto.Adapters.SQL.to_sql/3 for more information.","ref":"Journey.Repo.html#to_sql/2","title":"Journey.Repo.to_sql/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.transaction/2.","ref":"Journey.Repo.html#transaction/2","title":"Journey.Repo.transaction/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update/2.","ref":"Journey.Repo.html#update/2","title":"Journey.Repo.update/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update!/2.","ref":"Journey.Repo.html#update!/2","title":"Journey.Repo.update!/2","type":"function"},{"doc":"Callback implementation for Ecto.Repo.update_all/3.","ref":"Journey.Repo.html#update_all/3","title":"Journey.Repo.update_all/3","type":"function"},{"doc":"The data structure for defining a step in a process.Example: Using Journey.Step to Define a Processiex&gt; _process = %Journey.Process{ ...&gt; process_id: &quot;horoscopes-r-us&quot;, ...&gt; steps: [ ...&gt; %Journey.Step{name: :first_name}, ...&gt; %Journey.Step{name: :birth_month}, ...&gt; %Journey.Step{name: :birth_day}, ...&gt; %Journey.Step{ ...&gt; name: :astrological_sign, ...&gt; func: fn _values -&gt; ...&gt; # Everyone is a Taurus! ...&gt; {:ok, &quot;taurus&quot;} ...&gt; end, ...&gt; blocked_by: [ ...&gt; %Journey.BlockedBy{step_name: :birth_month, condition: :provided}, ...&gt; %Journey.BlockedBy{step_name: :birth_day, condition: :provided} ...&gt; ] ...&gt; }, ...&gt; %Journey.Step{ ...&gt; name: :horoscope, ...&gt; func: fn values -&gt; ...&gt; name = values[:first_name].value ...&gt; sign = values[:astrological_sign].value ...&gt; { ...&gt; :ok, ...&gt; &quot;\#{name}! You are a \#{sign}! Now is the perfect time to smash the racist patriarchy!&quot; ...&gt; } ...&gt; end, ...&gt; blocked_by: [ ...&gt; %Journey.BlockedBy{step_name: :first_name, condition: :provided}, ...&gt; %Journey.BlockedBy{step_name: :astrological_sign, condition: :provided} ...&gt; ] ...&gt; } ...&gt; ] ...&gt; }","ref":"Journey.Step.html","title":"Journey.Step","type":"module"},{"doc":"Stores the definition of a process step.nameThe name of the step, some examples: :first_name &quot;horoscope&quot; &quot;offer_rate&quot;funcThe function that computes the value for the step.The function accepts one parameter, which contains the current state of the execution.When the function computes the value, it should return it as part of a tuple: {:ok, value}.If the function was unable to compute the value, with a retriable error, it should return the tuple {:retriable, error_details}.Any other value will be treated as a non-retriable error.blocked_byA collection of conditions that must be be true for the computation to take place.TODO: examples. make those into functions.","ref":"Journey.Step.html#t:t/0","title":"Journey.Step.t/0","type":"type"},{"doc":"","ref":"Journey.Utilities.html","title":"Journey.Utilities","type":"module"},{"doc":"","ref":"Journey.Utilities.html#convert_key_strings_to_existing_atoms!/1","title":"Journey.Utilities.convert_key_strings_to_existing_atoms!/1","type":"function"},{"doc":"","ref":"Journey.Utilities.html#curent_unix_time_ms/0","title":"Journey.Utilities.curent_unix_time_ms/0","type":"function"},{"doc":"The structure containing the value assigned to a step.","ref":"Journey.Value.html","title":"Journey.Value","type":"module"},{"doc":"","ref":"Journey.Value.html#convert_from_string_keys/1","title":"Journey.Value.convert_from_string_keys/1","type":"function"},{"doc":"Contains the value assigned to a process step.nameThe name of the step associated with this value.Example: :first_name.valueThe actual value.Example: &quot;Mario&quot;.update_timeThe time (in Unix Epoch seconds) when the last update took place.Example: 1615793585.statusThe status of this value.Example: :not_computed.","ref":"Journey.Value.html#t:t/0","title":"Journey.Value.t/0","type":"type"},{"doc":"","ref":"Journey.ValueCondition.html","title":"Journey.ValueCondition","type":"module"},{"doc":"JourneyJourney is an Elixir package that simplifies defining and running persistent, workflow-like processes simply, scalably, and reliably.Examples of applications that could be powered by processes defined and executed with Journey:a web site for computing horoscopes,a food delivery application,a web site for accepting and processing credit card applications.Journey processes are designed to be persistent and resilient, to survivce service restarts, and to, quite literally, scale with your service.Please see the Livebook in ./examples as well as Journey documentation for more information.","ref":"readme.html","title":"Journey","type":"extras"},{"doc":"Full documentation can be found at https://hexdocs.pm/journey.","ref":"readme.html#documentation","title":"Journey - Documentation","type":"extras"},{"doc":"MIT License Copyright (c) 2021 Mark Markaryan Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]